User Manual: Write "Git" instead of "GIT"
[git/dscho.git] / git-submodule.sh
blob850d4235a003a9934681b319199e82da07a865dd
1 #!/bin/sh
3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
15 OPTIONS_SPEC=
16 . git-sh-setup
17 . git-parse-remote
18 require_work_tree
20 command=
21 branch=
22 reference=
23 cached=
24 files=
25 nofetch=
26 update=
27 prefix=
29 # Resolve relative url by appending to parent's url
30 resolve_relative_url ()
32 remote=$(get_default_remote)
33 remoteurl=$(git config "remote.$remote.url") ||
34 die "remote ($remote) does not have a url defined in .git/config"
35 url="$1"
36 remoteurl=${remoteurl%/}
37 while test -n "$url"
39 case "$url" in
40 ../*)
41 url="${url#../}"
42 remoteurl="${remoteurl%/*}"
44 ./*)
45 url="${url#./}"
48 break;;
49 esac
50 done
51 echo "$remoteurl/${url%/}"
55 # Get submodule info for registered submodules
56 # $@ = path to limit submodule list
58 module_list()
60 git ls-files --error-unmatch --stage -- "$@" | grep '^160000 '
64 # Map submodule path to submodule name
66 # $1 = path
68 module_name()
70 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
71 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
72 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
73 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
74 test -z "$name" &&
75 die "No submodule mapping found in .gitmodules for path '$path'"
76 echo "$name"
80 # Clone a submodule
82 # Prior to calling, cmd_update checks that a possibly existing
83 # path is not a git repository.
84 # Likewise, cmd_add checks that path does not exist at all,
85 # since it is the location of a new submodule.
87 module_clone()
89 path=$1
90 url=$2
91 reference="$3"
93 # If there already is a directory at the submodule path,
94 # expect it to be empty (since that is the default checkout
95 # action) and try to remove it.
96 # Note: if $path is a symlink to a directory the test will
97 # succeed but the rmdir will fail. We might want to fix this.
98 if test -d "$path"
99 then
100 rmdir "$path" 2>/dev/null ||
101 die "Directory '$path' exists, but is neither empty nor a git repository"
104 test -e "$path" &&
105 die "A file already exist at path '$path'"
107 if test -n "$reference"
108 then
109 git-clone "$reference" -n "$url" "$path"
110 else
111 git-clone -n "$url" "$path"
112 fi ||
113 die "Clone of '$url' into submodule path '$path' failed"
117 # Add a new submodule to the working tree, .gitmodules and the index
119 # $@ = repo path
121 # optional branch is stored in global branch variable
123 cmd_add()
125 # parse $args after "submodule ... add".
126 while test $# -ne 0
128 case "$1" in
129 -b | --branch)
130 case "$2" in '') usage ;; esac
131 branch=$2
132 shift
134 -q|--quiet)
135 GIT_QUIET=1
137 --reference)
138 case "$2" in '') usage ;; esac
139 reference="--reference=$2"
140 shift
142 --reference=*)
143 reference="$1"
144 shift
147 shift
148 break
151 usage
154 break
156 esac
157 shift
158 done
160 repo=$1
161 path=$2
163 if test -z "$path"; then
164 path=$(echo "$repo" |
165 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
168 if test -z "$repo" -o -z "$path"; then
169 usage
172 # assure repo is absolute or relative to parent
173 case "$repo" in
174 ./*|../*)
175 # dereference source url relative to parent's url
176 realrepo=$(resolve_relative_url "$repo") || exit
178 *:*|/*)
179 # absolute url
180 realrepo=$repo
183 die "repo URL: '$repo' must be absolute or begin with ./|../"
185 esac
187 # normalize path:
188 # multiple //; leading ./; /./; /../; trailing /
189 path=$(printf '%s/\n' "$path" |
190 sed -e '
191 s|//*|/|g
192 s|^\(\./\)*||
193 s|/\./|/|g
194 :start
195 s|\([^/]*\)/\.\./||
196 tstart
197 s|/*$||
199 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
200 die "'$path' already exists in the index"
202 # perhaps the path exists and is already a git repo, else clone it
203 if test -e "$path"
204 then
205 if test -d "$path"/.git -o -f "$path"/.git
206 then
207 echo "Adding existing repo at '$path' to the index"
208 else
209 die "'$path' already exists and is not a valid git repo"
212 case "$repo" in
213 ./*|../*)
214 url=$(resolve_relative_url "$repo") || exit
217 url="$repo"
219 esac
220 git config submodule."$path".url "$url"
221 else
223 module_clone "$path" "$realrepo" "$reference" || exit
225 unset GIT_DIR
226 cd "$path" &&
227 # ash fails to wordsplit ${branch:+-b "$branch"...}
228 case "$branch" in
229 '') git checkout -f -q ;;
230 ?*) git checkout -f -q -b "$branch" "origin/$branch" ;;
231 esac
232 ) || die "Unable to checkout submodule '$path'"
235 git add "$path" ||
236 die "Failed to add submodule '$path'"
238 git config -f .gitmodules submodule."$path".path "$path" &&
239 git config -f .gitmodules submodule."$path".url "$repo" &&
240 git add .gitmodules ||
241 die "Failed to register submodule '$path'"
245 # Execute an arbitrary command sequence in each checked out
246 # submodule
248 # $@ = command to execute
250 cmd_foreach()
252 # parse $args after "submodule ... foreach".
253 while test $# -ne 0
255 case "$1" in
256 -q|--quiet)
257 GIT_QUIET=1
259 --recursive)
260 recursive=1
263 usage
266 break
268 esac
269 shift
270 done
272 module_list |
273 while read mode sha1 stage path
275 if test -e "$path"/.git
276 then
277 say "Entering '$prefix$path'"
278 name=$(module_name "$path")
280 prefix="$prefix$path/"
281 unset GIT_DIR
282 cd "$path" &&
283 eval "$@" &&
284 if test -n "$recursive"
285 then
286 cmd_foreach "--recursive" "$@"
288 ) ||
289 die "Stopping at '$path'; script returned non-zero status."
291 done
295 # Register submodules in .git/config
297 # $@ = requested paths (default to all)
299 cmd_init()
301 # parse $args after "submodule ... init".
302 while test $# -ne 0
304 case "$1" in
305 -q|--quiet)
306 GIT_QUIET=1
309 shift
310 break
313 usage
316 break
318 esac
319 shift
320 done
322 module_list "$@" |
323 while read mode sha1 stage path
325 # Skip already registered paths
326 name=$(module_name "$path") || exit
327 url=$(git config submodule."$name".url)
328 test -z "$url" || continue
330 url=$(git config -f .gitmodules submodule."$name".url)
331 test -z "$url" &&
332 die "No url found for submodule path '$path' in .gitmodules"
334 # Possibly a url relative to parent
335 case "$url" in
336 ./*|../*)
337 url=$(resolve_relative_url "$url") || exit
339 esac
341 git config submodule."$name".url "$url" ||
342 die "Failed to register url for submodule path '$path'"
344 upd="$(git config -f .gitmodules submodule."$name".update)"
345 test -z "$upd" ||
346 git config submodule."$name".update "$upd" ||
347 die "Failed to register update mode for submodule path '$path'"
349 say "Submodule '$name' ($url) registered for path '$path'"
350 done
354 # Update each submodule path to correct revision, using clone and checkout as needed
356 # $@ = requested paths (default to all)
358 cmd_update()
360 # parse $args after "submodule ... update".
361 orig_args="$@"
362 while test $# -ne 0
364 case "$1" in
365 -q|--quiet)
366 shift
367 GIT_QUIET=1
369 -i|--init)
370 init=1
371 shift
373 -N|--no-fetch)
374 shift
375 nofetch=1
377 -r|--rebase)
378 shift
379 update="rebase"
381 --reference)
382 case "$2" in '') usage ;; esac
383 reference="--reference=$2"
384 shift 2
386 --reference=*)
387 reference="$1"
388 shift
390 -m|--merge)
391 shift
392 update="merge"
394 --recursive)
395 shift
396 recursive=1
399 shift
400 break
403 usage
406 break
408 esac
409 done
411 if test -n "$init"
412 then
413 cmd_init "--" "$@" || return
416 module_list "$@" |
417 while read mode sha1 stage path
419 name=$(module_name "$path") || exit
420 url=$(git config submodule."$name".url)
421 update_module=$(git config submodule."$name".update)
422 if test -z "$url"
423 then
424 # Only mention uninitialized submodules when its
425 # path have been specified
426 test "$#" != "0" &&
427 say "Submodule path '$path' not initialized" &&
428 say "Maybe you want to use 'update --init'?"
429 continue
432 if ! test -d "$path"/.git -o -f "$path"/.git
433 then
434 module_clone "$path" "$url" "$reference"|| exit
435 subsha1=
436 else
437 subsha1=$(unset GIT_DIR; cd "$path" &&
438 git rev-parse --verify HEAD) ||
439 die "Unable to find current revision in submodule path '$path'"
442 if ! test -z "$update"
443 then
444 update_module=$update
447 if test "$subsha1" != "$sha1"
448 then
449 force=
450 if test -z "$subsha1"
451 then
452 force="-f"
455 if test -z "$nofetch"
456 then
457 (unset GIT_DIR; cd "$path" &&
458 git-fetch) ||
459 die "Unable to fetch in submodule path '$path'"
462 case "$update_module" in
463 rebase)
464 command="git rebase"
465 action="rebase"
466 msg="rebased onto"
468 merge)
469 command="git merge"
470 action="merge"
471 msg="merged in"
474 command="git checkout $force -q"
475 action="checkout"
476 msg="checked out"
478 esac
480 (unset GIT_DIR; cd "$path" && $command "$sha1") ||
481 die "Unable to $action '$sha1' in submodule path '$path'"
482 say "Submodule path '$path': $msg '$sha1'"
485 if test -n "$recursive"
486 then
487 (unset GIT_DIR; cd "$path" && cmd_update $orig_args) ||
488 die "Failed to recurse into submodule path '$path'"
490 done
493 set_name_rev () {
494 revname=$( (
495 unset GIT_DIR
496 cd "$1" && {
497 git describe "$2" 2>/dev/null ||
498 git describe --tags "$2" 2>/dev/null ||
499 git describe --contains "$2" 2>/dev/null ||
500 git describe --all --always "$2"
503 test -z "$revname" || revname=" ($revname)"
506 # Show commit summary for submodules in index or working tree
508 # If '--cached' is given, show summary between index and given commit,
509 # or between working tree and given commit
511 # $@ = [commit (default 'HEAD'),] requested paths (default all)
513 cmd_summary() {
514 summary_limit=-1
515 for_status=
516 diff_cmd=diff-index
518 # parse $args after "submodule ... summary".
519 while test $# -ne 0
521 case "$1" in
522 --cached)
523 cached="$1"
525 --files)
526 files="$1"
528 --for-status)
529 for_status="$1"
531 -n|--summary-limit)
532 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
533 then
535 else
536 usage
538 shift
541 shift
542 break
545 usage
548 break
550 esac
551 shift
552 done
554 test $summary_limit = 0 && return
556 if rev=$(git rev-parse -q --verify "$1^0")
557 then
558 head=$rev
559 shift
560 else
561 head=HEAD
564 if [ -n "$files" ]
565 then
566 test -n "$cached" &&
567 die "--cached cannot be used with --files"
568 diff_cmd=diff-files
569 head=
572 cd_to_toplevel
573 # Get modified modules cared by user
574 modules=$(git $diff_cmd $cached --raw $head -- "$@" |
575 egrep '^:([0-7]* )?160000' |
576 while read mod_src mod_dst sha1_src sha1_dst status name
578 # Always show modules deleted or type-changed (blob<->module)
579 test $status = D -o $status = T && echo "$name" && continue
580 # Also show added or modified modules which are checked out
581 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
582 echo "$name"
583 done
586 test -z "$modules" && return
588 git $diff_cmd $cached --raw $head -- $modules |
589 egrep '^:([0-7]* )?160000' |
590 cut -c2- |
591 while read mod_src mod_dst sha1_src sha1_dst status name
593 if test -z "$cached" &&
594 test $sha1_dst = 0000000000000000000000000000000000000000
595 then
596 case "$mod_dst" in
597 160000)
598 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
600 100644 | 100755 | 120000)
601 sha1_dst=$(git hash-object $name)
603 000000)
604 ;; # removed
606 # unexpected type
607 echo >&2 "unexpected mode $mod_dst"
608 continue ;;
609 esac
611 missing_src=
612 missing_dst=
614 test $mod_src = 160000 &&
615 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
616 missing_src=t
618 test $mod_dst = 160000 &&
619 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
620 missing_dst=t
622 total_commits=
623 case "$missing_src,$missing_dst" in
625 errmsg=" Warn: $name doesn't contain commit $sha1_src"
628 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
630 t,t)
631 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
634 errmsg=
635 total_commits=$(
636 if test $mod_src = 160000 -a $mod_dst = 160000
637 then
638 range="$sha1_src...$sha1_dst"
639 elif test $mod_src = 160000
640 then
641 range=$sha1_src
642 else
643 range=$sha1_dst
645 GIT_DIR="$name/.git" \
646 git log --pretty=oneline --first-parent $range | wc -l
648 total_commits=" ($(($total_commits + 0)))"
650 esac
652 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
653 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
654 if test $status = T
655 then
656 if test $mod_dst = 160000
657 then
658 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
659 else
660 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
662 else
663 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
665 if test -n "$errmsg"
666 then
667 # Don't give error msg for modification whose dst is not submodule
668 # i.e. deleted or changed to blob
669 test $mod_dst = 160000 && echo "$errmsg"
670 else
671 if test $mod_src = 160000 -a $mod_dst = 160000
672 then
673 limit=
674 test $summary_limit -gt 0 && limit="-$summary_limit"
675 GIT_DIR="$name/.git" \
676 git log $limit --pretty='format: %m %s' \
677 --first-parent $sha1_src...$sha1_dst
678 elif test $mod_dst = 160000
679 then
680 GIT_DIR="$name/.git" \
681 git log --pretty='format: > %s' -1 $sha1_dst
682 else
683 GIT_DIR="$name/.git" \
684 git log --pretty='format: < %s' -1 $sha1_src
686 echo
688 echo
689 done |
690 if test -n "$for_status"; then
691 echo "# Modified submodules:"
692 echo "#"
693 sed -e 's|^|# |' -e 's|^# $|#|'
694 else
699 # List all submodules, prefixed with:
700 # - submodule not initialized
701 # + different revision checked out
703 # If --cached was specified the revision in the index will be printed
704 # instead of the currently checked out revision.
706 # $@ = requested paths (default to all)
708 cmd_status()
710 # parse $args after "submodule ... status".
711 orig_args="$@"
712 while test $# -ne 0
714 case "$1" in
715 -q|--quiet)
716 GIT_QUIET=1
718 --cached)
719 cached=1
721 --recursive)
722 recursive=1
725 shift
726 break
729 usage
732 break
734 esac
735 shift
736 done
738 module_list "$@" |
739 while read mode sha1 stage path
741 name=$(module_name "$path") || exit
742 url=$(git config submodule."$name".url)
743 displaypath="$prefix$path"
744 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
745 then
746 say "-$sha1 $displaypath"
747 continue;
749 set_name_rev "$path" "$sha1"
750 if git diff-files --quiet -- "$path"
751 then
752 say " $sha1 $displaypath$revname"
753 else
754 if test -z "$cached"
755 then
756 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
757 set_name_rev "$path" "$sha1"
759 say "+$sha1 $displaypath$revname"
762 if test -n "$recursive"
763 then
765 prefix="$displaypath/"
766 unset GIT_DIR
767 cd "$path" &&
768 cmd_status $orig_args
769 ) ||
770 die "Failed to recurse into submodule path '$path'"
772 done
775 # Sync remote urls for submodules
776 # This makes the value for remote.$remote.url match the value
777 # specified in .gitmodules.
779 cmd_sync()
781 while test $# -ne 0
783 case "$1" in
784 -q|--quiet)
785 GIT_QUIET=1
786 shift
789 shift
790 break
793 usage
796 break
798 esac
799 done
800 cd_to_toplevel
801 module_list "$@" |
802 while read mode sha1 stage path
804 name=$(module_name "$path")
805 url=$(git config -f .gitmodules --get submodule."$name".url)
807 # Possibly a url relative to parent
808 case "$url" in
809 ./*|../*)
810 url=$(resolve_relative_url "$url") || exit
812 esac
814 if test -e "$path"/.git
815 then
817 unset GIT_DIR
818 cd "$path"
819 remote=$(get_default_remote)
820 say "Synchronizing submodule url for '$name'"
821 git config remote."$remote".url "$url"
824 done
827 # This loop parses the command line arguments to find the
828 # subcommand name to dispatch. Parsing of the subcommand specific
829 # options are primarily done by the subcommand implementations.
830 # Subcommand specific options such as --branch and --cached are
831 # parsed here as well, for backward compatibility.
833 while test $# != 0 && test -z "$command"
835 case "$1" in
836 add | foreach | init | update | status | summary | sync)
837 command=$1
839 -q|--quiet)
840 GIT_QUIET=1
842 -b|--branch)
843 case "$2" in
845 usage
847 esac
848 branch="$2"; shift
850 --cached)
851 cached="$1"
854 break
857 usage
860 break
862 esac
863 shift
864 done
866 # No command word defaults to "status"
867 test -n "$command" || command=status
869 # "-b branch" is accepted only by "add"
870 if test -n "$branch" && test "$command" != add
871 then
872 usage
875 # "--cached" is accepted only by "status" and "summary"
876 if test -n "$cached" && test "$command" != status -a "$command" != summary
877 then
878 usage
881 "cmd_$command" "$@"